import java.io.*; 
import java.net.*; 

class UDPChat_halfServer extends Thread { 

	private DatagramSocket connectionlessSocket;

	public UDPChat_halfServer(DatagramSocket s) throws Exception {
		connectionlessSocket = s;
		start(); // Calls run()
	}

	public void run() {
		try {
			while(true) { 
				byte[] sendData = new byte[1024]; 
				byte[] receiveData = new byte[1024]; 

				// read the incoming information and display it
				DatagramPacket receivePacket = new DatagramPacket(receiveData, receiveData.length); 
				connectionlessSocket.receive(receivePacket);

				String sentence = new String(receivePacket.getData()); 
				System.out.println("user > " + sentence);
			}
		} catch (IOException e) {
		}
	}
}


class UDPChat_halfClient extends Thread {

	private DatagramSocket connectionlessSocket;
	private InetAddress IPAddress;
	private int port;
	private BufferedReader inFromLocal;

	public UDPChat_halfClient(DatagramSocket s, InetAddress IP, int p) throws Exception {
		connectionlessSocket = s;
		IPAddress = IP;
		port = p;
		inFromLocal = new BufferedReader(new InputStreamReader(System.in));
		start(); // Calls run()
	}

	public void run() {
		try {
			while(true) { 
				byte[] sendData = new byte[1024]; 
				byte[] receiveData = new byte[1024]; 

				// send what the user writes
				String sentence = inFromLocal.readLine(); 
				sendData = sentence.getBytes();
				DatagramPacket sendPacket = new DatagramPacket(sendData, sendData.length, IPAddress, port); 

				connectionlessSocket.send(sendPacket); 
			}
		} catch (IOException e) {
		}
	}
}

///////////////////////////////////////////////

class UDPChat_clientServer { 

	public static void main(String args[]) throws Exception {

		InetAddress IPAddress;
		int localPort;
		int remotePort;
		DatagramSocket activeSocket;
		byte[] receiveData = new byte[1024]; 
		byte[] sendData  = new byte[1024]; 


		if ((args.length<1)||(args.length>2)) {
			System.out.println("error");
			System.exit(0);
		}
		if (args.length==1) {
			localPort = Integer.parseInt(args[0]);
			activeSocket = new DatagramSocket(localPort);
			// wait for the "hello" message 
			DatagramPacket receivePacket = new DatagramPacket(receiveData, receiveData.length); 
			activeSocket.receive(receivePacket);

			IPAddress = receivePacket.getAddress(); 
			remotePort = receivePacket.getPort(); 
		}
		else {
			IPAddress = InetAddress.getByName(args[0]); 
			remotePort = Integer.parseInt(args[1]);
			activeSocket = new DatagramSocket(); 
			// send the "hello" message
			String sentence = "hello"; 
			sendData = sentence.getBytes();
			DatagramPacket sendPacket = new DatagramPacket(sendData, sendData.length, IPAddress, remotePort); 
			activeSocket.send(sendPacket); 
		}

		// create the two threads 
		new UDPChat_halfServer(activeSocket);
		new UDPChat_halfClient(activeSocket, IPAddress, remotePort);
	}
}


